# -*- coding: utf-8 -*-
# Generated by Django 1.11.9 on 2020-02-04 10:21
from __future__ import unicode_literals

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import xyz_util.modelutils


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('course', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='Class',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=64, unique=True, verbose_name='\u540d\u79f0')),
                ('short_name', models.CharField(blank=True, db_index=True, max_length=64, null=True, verbose_name='\u7b80\u79f0')),
                ('code', models.CharField(blank=True, db_index=True, default='', max_length=64, verbose_name='\u62fc\u97f3\u7f29\u5199')),
                ('create_time', models.DateTimeField(auto_now_add=True, verbose_name='\u521b\u5efa\u65f6\u95f4')),
                ('modify_time', models.DateTimeField(auto_now=True, verbose_name='\u4fee\u6539\u65f6\u95f4')),
                ('is_active', models.BooleanField(default=True, verbose_name='\u6709\u6548')),
            ],
            options={
                'ordering': ('grade', 'name'),
                'verbose_name': '\u73ed\u7ea7',
                'verbose_name_plural': '\u73ed\u7ea7',
            },
            bases=(xyz_util.modelutils.CodeMixin, models.Model),
        ),
        migrations.CreateModel(
            name='ClassCourse',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('clazz', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='class_courses', related_query_name='class_course', to='school.Class', verbose_name='\u73ed\u7ea7')),
                ('course', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='school_class_courses', to='course.Course', verbose_name='\u8bfe\u7a0b')),
            ],
            options={
                'verbose_name': '\u73ed\u7ea7\u8bfe\u7a0b',
                'verbose_name_plural': '\u73ed\u7ea7\u8bfe\u7a0b',
            },
        ),
        migrations.CreateModel(
            name='College',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(db_index=True, max_length=64, verbose_name='\u540d\u79f0')),
                ('code', models.CharField(blank=True, default='', max_length=64, unique=True, verbose_name='\u62fc\u97f3\u7f29\u5199')),
                ('short_name', models.CharField(blank=True, db_index=True, default='', max_length=64, verbose_name='\u7b80\u79f0')),
                ('create_time', models.DateTimeField(auto_now_add=True, verbose_name='\u521b\u5efa\u65f6\u95f4')),
                ('update_time', models.DateTimeField(auto_now=True, verbose_name='\u4fee\u6539\u65f6\u95f4')),
            ],
            options={
                'ordering': ('name',),
                'verbose_name': '\u9662\u7cfb',
                'verbose_name_plural': '\u9662\u7cfb',
            },
            bases=(xyz_util.modelutils.CodeMixin, models.Model),
        ),
        migrations.CreateModel(
            name='Grade',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('number', models.PositiveSmallIntegerField(default=1, unique=True, verbose_name='\u7f16\u53f7')),
                ('name', models.CharField(blank=True, db_index=True, max_length=64, verbose_name='\u540d\u79f0')),
                ('class_count', models.PositiveSmallIntegerField(default=3, verbose_name='\u73ed\u6570')),
            ],
            options={
                'ordering': ('number',),
                'verbose_name': '\u5e74\u7ea7',
                'verbose_name_plural': '\u5e74\u7ea7',
            },
        ),
        migrations.CreateModel(
            name='Major',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(db_index=True, max_length=64, verbose_name='\u540d\u79f0')),
                ('short_name', models.CharField(blank=True, db_index=True, default='', max_length=64, verbose_name='\u7b80\u79f0')),
                ('code', models.CharField(blank=True, default='', max_length=64, unique=True, verbose_name='\u62fc\u97f3\u7f29\u5199')),
                ('study_years', models.PositiveSmallIntegerField(blank=True, default=3, verbose_name='\u5e74\u5236')),
                ('create_time', models.DateTimeField(auto_now_add=True, verbose_name='\u521b\u5efa\u65f6\u95f4')),
                ('update_time', models.DateTimeField(auto_now=True, verbose_name='\u4fee\u6539\u65f6\u95f4')),
                ('college', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, related_name='majors', to='school.College', verbose_name='\u9662\u7cfb')),
            ],
            options={
                'ordering': ('name',),
                'verbose_name': '\u4e13\u4e1a',
                'verbose_name_plural': '\u4e13\u4e1a',
            },
            bases=(xyz_util.modelutils.CodeMixin, models.Model),
        ),
        migrations.CreateModel(
            name='Session',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('number', models.PositiveSmallIntegerField(unique=True, verbose_name='\u7f16\u53f7')),
                ('name', models.CharField(blank=True, db_index=True, max_length=64, verbose_name='\u540d\u79f0')),
                ('begin_date', models.DateField(blank=True, verbose_name='\u5f00\u59cb\u65e5\u671f')),
                ('end_date', models.DateField(blank=True, verbose_name='\u7ed3\u675f\u65e5\u671f')),
            ],
            options={
                'ordering': ('number',),
                'verbose_name': '\u5c4a\u522b',
                'verbose_name_plural': '\u5c4a\u522b',
            },
        ),
        migrations.CreateModel(
            name='Student',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('number', models.CharField(max_length=32, unique=True, verbose_name='\u5b66\u53f7')),
                ('name', models.CharField(db_index=True, max_length=32, verbose_name='\u59d3\u540d')),
                ('code', models.CharField(blank=True, db_index=True, default='', max_length=64, verbose_name='\u62fc\u97f3\u7f29\u5199')),
                ('create_time', models.DateTimeField(auto_now_add=True, db_index=True, verbose_name='\u521b\u5efa\u65f6\u95f4')),
                ('modify_time', models.DateTimeField(auto_now=True, verbose_name='\u4fee\u6539\u65f6\u95f4')),
                ('is_active', models.BooleanField(default=True, verbose_name='\u6709\u6548')),
                ('is_bind', models.BooleanField(default=False, verbose_name='\u5df2\u7ed1')),
                ('courses', models.ManyToManyField(blank=True, related_name='school_students', to='course.Course', verbose_name='\u8bfe\u7a0b')),
                ('entrance_session', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='entrance_students', to='school.Session', verbose_name='\u5165\u5b66\u5c4a\u522b')),
                ('grade', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='students', to='school.Grade', verbose_name='\u5e74\u7ea7')),
                ('graduate_session', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, related_name='graduate_students', to='school.Session', verbose_name='\u6bd5\u4e1a\u5c4a\u522b')),
                ('user', models.OneToOneField(null=True, on_delete=django.db.models.deletion.PROTECT, related_name='as_school_student', to=settings.AUTH_USER_MODEL, verbose_name='user')),
            ],
            options={
                'ordering': ('number',),
                'verbose_name': '\u5b66\u751f',
                'verbose_name_plural': '\u5b66\u751f',
            },
            bases=(xyz_util.modelutils.CodeMixin, models.Model),
        ),
        migrations.CreateModel(
            name='Teacher',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(db_index=True, max_length=32, verbose_name='\u59d3\u540d')),
                ('code', models.CharField(blank=True, db_index=True, default='', max_length=64, verbose_name='\u62fc\u97f3\u7f29\u5199')),
                ('create_time', models.DateTimeField(auto_now_add=True, verbose_name='\u521b\u5efa\u65f6\u95f4')),
                ('modify_time', models.DateTimeField(auto_now=True, verbose_name='\u4fee\u6539\u65f6\u95f4')),
                ('classes', models.ManyToManyField(blank=True, related_name='teachers', through='school.ClassCourse', to='school.Class', verbose_name='\u73ed\u7ea7')),
                ('courses', models.ManyToManyField(blank=True, related_name='school_teachers', through='school.ClassCourse', to='course.Course', verbose_name='\u8bfe\u7a0b')),
                ('user', models.OneToOneField(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='as_school_teacher', to=settings.AUTH_USER_MODEL, verbose_name='\u7f51\u7ad9\u7528\u6237')),
            ],
            options={
                'ordering': ('-create_time',),
                'verbose_name': '\u8001\u5e08',
                'verbose_name_plural': '\u8001\u5e08',
            },
            bases=(xyz_util.modelutils.CodeMixin, models.Model),
        ),
        migrations.AddField(
            model_name='major',
            name='students',
            field=models.ManyToManyField(related_name='majors', to='school.Student'),
        ),
        migrations.AddField(
            model_name='classcourse',
            name='teacher',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='class_courses', to='school.Teacher', verbose_name='\u8001\u5e08'),
        ),
        migrations.AddField(
            model_name='class',
            name='courses',
            field=models.ManyToManyField(blank=True, related_name='school_classes', through='school.ClassCourse', to='course.Course', verbose_name='\u8bfe\u7a0b'),
        ),
        migrations.AddField(
            model_name='class',
            name='entrance_session',
            field=models.ForeignKey(blank=True, on_delete=django.db.models.deletion.CASCADE, related_name='entrance_classes', to='school.Session', verbose_name='\u5165\u5b66\u5c4a\u522b'),
        ),
        migrations.AddField(
            model_name='class',
            name='grade',
            field=models.ForeignKey(blank=True, on_delete=django.db.models.deletion.CASCADE, related_name='classes', to='school.Grade', verbose_name='\u5e74\u7ea7'),
        ),
        migrations.AddField(
            model_name='class',
            name='graduate_session',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='graduate_classes', to='school.Session', verbose_name='\u6bd5\u4e1a\u5c4a\u522b'),
        ),
        migrations.AddField(
            model_name='class',
            name='primary_teacher',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, related_name='primary_classes', to='school.Teacher', verbose_name='\u73ed\u4e3b\u4efb'),
        ),
        migrations.AddField(
            model_name='class',
            name='students',
            field=models.ManyToManyField(blank=True, related_name='classes', related_query_name='class', to='school.Student', verbose_name='\u5b66\u751f'),
        ),
        migrations.AlterUniqueTogether(
            name='classcourse',
            unique_together=set([('clazz', 'course')]),
        ),
    ]
